

#include <stdio.h>
#include <stdlib.h>

FILE *fp1, *fp2, *fp2a, *fp3;
char *n1, *n2, *n2a;
unsigned char hdr1[128];	/* CMD header of file we're patching */
unsigned char hdr2[128];	/* CMD header of file containing X1 segment */

#ifndef SEEK_SET
#define SEEK_SET 0
#endif

#ifdef __PACIFIC__
#define AV0 "LIOSMERG"
#else
#define AV0 argv[0]
#endif

long offset = 0;

void copy_data(FILE *src, long len, char *desc)
{
	int ch;

	fseek(src, offset, SEEK_SET);
	offset += len;
	printf("Copying %4lx bytes from %s\n", len, 
			(src == fp1) ? n1 : 
			(src == fp2) ? n2 :
			n2a);
	while (len)
	{
		ch = fgetc(src);
		if (ch == EOF)
		{
			fprintf(stderr, "Unexpected EOF on file %s\n", 
					(src == fp1) ? n1 : 
					(src == fp2) ? n2 :
					n2a);
			exit(1);
		}
		fputc(ch, fp3);
		--len;
	}
}

int main(int argc, char **argv)
{
	if (argc < 4)
	{
		fprintf(stderr, "Syntax: %s oldlogo.cmd patch.cmd "
				"newlogo.cmd\n", AV0);
		return 1;
	}
	n1 = argv[1];
	n2 = argv[2];
	n2a = argv[3];
	fp1 = fopen(argv[1], "rb");
	if (!fp1)
	{
		perror(argv[1]);
		return 1;
	}
	fp2 = fopen(argv[2], "rb");
	if (!fp2)
	{
		perror(argv[2]);
		return 1;
	}
	fp2a = fopen(argv[3], "rb");
	if (!fp2)
	{
		perror(argv[3]);
		return 1;
	}
	fp3 = fopen(argv[4], "w+b");
	if (!fp3)
	{
		perror(argv[4]);
		return 1;
	}
	copy_data(fp1,   128,          "Header");
	copy_data(fp1, 0x1E8,          "C runtime");
	copy_data(fp2, 0xDD4  - 0x1E8, "LIOS code");
	copy_data(fp1, 0xD070 - 0xDD4, "LOGO code");
	copy_data(fp2, 0x434,          "LIOS data");
	copy_data(fp1, 0x2010 - 0x434, "LOGO data");
	if (fread(hdr2, 1, 128, fp2a) < 128)
	{
		fprintf(stderr, "Can't read from %s\n", argv[3]);
	}
	else
	{
/* Copy the X1 segment across from vgalios2.cmd */
		unsigned long offs, len;
	       
		len = (hdr2[2] * 4096) + (hdr2[1] * 16);
		offset = 128;
		/* Load the header of the existing CMD file */
		fseek(fp3, 0, SEEK_SET);
		fread(hdr1, 1, 128, fp3);
		offs = (hdr1[ 2] * 4096L) + (hdr1[ 1] * 16L) +
		         (hdr1[11] * 4096L) + (hdr1[10] * 16L) + 0x80L;
		fseek(fp3, offs, SEEK_SET);	
		copy_data(fp2a, len, "LIOS X1 code"); 
		fseek(fp3, 0x1B, 0);
		hdr2[0] = 5;	/* X1 */
		fwrite(hdr2, 1, 9, fp3);
		fflush(fp2a);
	}

	fclose(fp3);
	fclose(fp2a);
	fclose(fp2);
	fclose(fp1);
	return 0;
}
